/*---------------------------------------------------------+
I                                                          I
I  Programme         : Programme Minimum de communication  I
I                                                          I
I  Auteur            : T Colar                             I
I                                                          I
+---------------------------------------------------------*/

#define BANDEAU "RESEAUX : COMMIN, Version 3.0, 18 Septembre 1997"

/*---------------------------------------------------------+
I                    INCLUDES  GENERAUX                    I
+---------------------------------------------------------*/

#include <stdio.h>
#include <setjmp.h>
#include <process.h>
#include <string.h>

#include <iostream.h>
#include <fstream.h>

#include "modres.h"
#include "videotext.h"
/*---------------------------------------------------------+
I                      DECLARATIONS GLOBALES               I
+---------------------------------------------------------*/

/*---------------------------------------------------------+
I                    TRAITEMENT DES ERREURS                I
+---------------------------------------------------------*/

int minitel=0;   //a 1 pour utiliser le minitel / sinon xmodem
                 // mis a 14 par l'argument "minitel" au lancement

jmp_buf point_de_retour;

BOOLEAN binit_modem ;

void erreur(char *message)
{
 if (!binit_modem)
 {
 printf("\nERREUR : %s\n",message);
 longjmp(point_de_retour,0);
 }
 else exit(0);
}

void emmetre_fichier()                 // emmision fichier txt
{
char c;
cout<<"EMISSION DE FICHIER"<<endl;
char ficname[20];
cout<<"Veuillez entrer le nom du fichier svp :";
cin>>ficname;
ifstream fi (ficname,ios::in);
if (fi.good()) cout<<"ouverture fichier OK"<<endl;
else cout<<"ouverture fichier : ERREUR"<<endl;
emission_octet(STX);
int i=0;
do
{
emission_octet(ficname[i]);
i++;
}
while (ficname[i]!=0);
emission_octet(NUL);
if (reception_octet()==ACK) cout<<"NOM DU FICHIER OK";
else cout<<"Nom du fichier ERREUR";
char ligne[256];
fi.getline(ligne,256);
while (!fi.eof())
{
i=0;
while (ligne[i]!=0)
  {
  emission_octet(ligne[i]);
  i++;
  }
  emission_octet(NUL);
  c=reception_octet();
  fi.getline(ligne,256);
}
emission_octet(ETX);
emission_octet(NUL);
}

void recevoir_fichier()      //reception fichier txt
{
cout<<"RECEPTION DU FICHIER : ";
char ficname[20];
char c;
int i=0;
do
{
c=reception_octet();
ficname[i]=c;
i++;
}
while(c!=NUL);
cout<<ficname<<endl;
ofstream fi (ficname,ios::out);
if (fi.good) { cout<<"ouverture ok"<<endl; emission_octet(ACK); }
else { cout<<"erreur de nom de fichier"<<endl; emission_octet(NAK); }
char ligne[256];
do
{
i=0;
ligne[i]=reception_octet();
while (ligne[i]!=0)
  {
  i++;
  ligne[i]=reception_octet();

  }
if (ligne[0]!=ETX) fi<<ligne<<endl;
emission_octet(ACK);
cout<<'.'<<flush;
}
while(ligne[0]!=ETX);
cout<<endl<<"FIN "<<endl;
}


void util_emet()        // utilisateur emetteur
{
char c;
cout<<"EMISSION DE FICHIER PAR XMODEM"<<endl;
char ficname[20];
cout<<"Veuillez entrer le nom du fichier svp :";
cin>>ficname;
ifstream fi (ficname,ios::in | ios::binary);
if (fi.good()) cout<<"ouverture fichier OK"<<endl;
else cout<<"ouverture fichier : ERREUR"<<endl;
emission_octet(DC1);
int i=0;
unsigned char numbloc=0;
do
{
emission_octet(ficname[i]);
i++;
}
while (ficname[i]!=0);
emission_octet(NUL);
if (reception_octet()!=ACK) {fi.close();}
                                     // emission xmodem
c=reception_octet(); //reception du NAK
char ligne[128];
 int nb;
do
{
 fi.read(ligne,128);
 nb=fi.gcount();
 if(nb<128) {for (i=nb-1;i!=128;i++) ligne[i]=SUB;};
 int compt=0;
 numbloc++;
 cout<<(int) numbloc<<"/"<<endl;
 do
 {
  emission_octet(SOH);
  emission_octet(numbloc);
  emission_octet(255-numbloc);
  int chksum=0;
  for (i=0; i!=128;i++) {emission_octet(ligne[i]);chksum+=ligne[i];}
  chksum=chksum%256;
  emission_octet((char) chksum);
  c=reception_octet();
  compt+=1;
  }
 while (c!=ACK && compt!=9);
 if (c!=ACK) cout<<"ERREUR (CHECKSUM ?";
 }
while (nb==128);
emission_octet(EOT);
c=reception_octet(); //ack
}

void util_recept()       // utilisateur recepteur
{
char c;
cout<<"RECEPTION DE FICHIER PAR XMODEM"<<endl;
char ficname[20];
cout<<"Veuillez entrer le nom du fichier svp :";
cin>>ficname;
fstream fi;
fi.open (ficname,ios::out | ios::binary);
if (fi.good()) cout<<"creation fichier OK"<<endl;
else cout<<"creation fichier : ERREUR"<<endl;
emission_octet(DC2);
int i=0;
unsigned char numbloc=1;
unsigned char n=0;
do

{
emission_octet(ficname[i]);
i++;
}
while (ficname[i]!=0);
emission_octet(NUL);
if (reception_octet()!=ACK) {fi.close();cout<<"pas ack";}
                                    // emission xmodem
emission_octet(NAK);
c=reception_octet();
do
{
if (c!=SOH) cout<<"pas soh";
n=reception_octet();
if(n!=numbloc) cout<<" numero de bloc invalide ";
else cout<<"bloc n"<< int(n) <<endl;

n=reception_octet();
if (n!=(255-numbloc)) cout<<" numero de bloc complement faux ";
for (int i=0;i!=128;i++) {c=reception_octet();fi<<c;}
c=reception_octet();//checksum
emission_octet(ACK);
numbloc++;
c=reception_octet();
}
while(c!=EOT);
emission_octet(ACK);
cout<<"FIN DE TRANSFERT."<<endl;
fi.close();
}


void serveur_recepteur()      // serveur recepteur
{
int i=0;
unsigned char numbloc=1;
unsigned char n=0;
char c;

cout<<"RECEPTION DE FICHIER PAR XMODEM"<<endl;
char ficname[20];
do
{
ficname[i]=reception_octet();
i++;
}
while (ficname[i-1]!=0);

cout<<"nom du fichier : "<<ficname<<endl;

fstream fi;
fi.open (ficname,ios::out | ios::binary);
if (fi.good()) cout<<"creation fichier OK"<<endl;
else cout<<"creation fichier : ERREUR"<<endl;


emission_octet(ACK);

emission_octet(NAK); //signal de demarage

c=reception_octet();
do
{
int err=0;
int chkok=0;


do
{
if (c!=SOH) cout<<"pas soh";
n=reception_octet();
if(n!=numbloc) cout<<" numero de bloc invalide ";
else cout<<"bloc n"<< int(n) <<endl;

n=reception_octet();
if (n!=(255-numbloc)) cout<<" numero de bloc complement faux ";

int chksum=0;
for (int i=0;i!=128;i++) {c=reception_octet();chksum+=c;fi<<c;}
c=reception_octet();//checksum
if (c==char(chksum%256)) {emission_octet(ACK); chkok=1;}
else {cout<<"checksum invalide "<<c<<" "<<char(chksum%256)<<endl; emission_octet(NAK); err+=1;}
if (err==9) exit(0);  // perdu
c=reception_octet();
}
while(! chkok);
numbloc++;
}
while(c!=EOT);
emission_octet(ACK);
cout<<"FIN DE TRANSFERT."<<endl;
fi.close();
}

void serveur_emmeteur()     // serveur emmeteur
{
char c;
cout<<"EMISSION DE FICHIER PAR XMODEM"<<endl;
char ficname[20];

int i=0;
char ligne[128];
 int nb;
unsigned char numbloc=0;
do
{
ficname[i]=reception_octet();
i++;
}
while (ficname[i-1]!=0);

cout<<"emmission du fichier "<<ficname<<endl;

ifstream fi (ficname,ios::in | ios::binary);
if (fi.good()) cout<<"ouverture fichier OK"<<endl;
else cout<<"ouverture fichier : ERREUR"<<endl;

emission_octet(ACK);
c=reception_octet(); //nak

do
{
 fi.read(ligne,128);
 nb=fi.gcount();
 if(nb<128) {for (i=nb-1;i!=128;i++) ligne[i]=SUB;};
 int compt=0;
 numbloc++;
 cout<<(int) numbloc<<"/"<<endl;
 do
 {
  emission_octet(SOH);
  emission_octet(numbloc);
  emission_octet(255-numbloc);
  int chksum=0;
  for (i=0; i!=128;i++) {emission_octet(ligne[i]);chksum+=ligne[i];}
  chksum=chksum%256;
  emission_octet((char) chksum);
  c=reception_octet();
  compt+=1;
  }
 while (c!=ACK && compt!=9);
 if (c!=ACK) cout<<"ERREUR (CHECKSUM ?";
 }
while (nb==128);
emission_octet(EOT);
c=reception_octet(); //ack
}









void recevoir_reponse_modem(char reponse[])  // ajout tp2 reseau
{
char c;
int i=0;
c=reception_octet();
//if (c!=CR) erreur("err rep1");
c=reception_octet();
//if (c!=LF) erreur("err rep2");
while(c!=CR)
{
reponse[i]=reception_octet();
c=reponse[i];
cout<<c<<flush;
i++;
}
reponse[i]=NUL;
c=reception_octet();
cout<<endl;
//if (c!=LF) erreur("err rep 3");
}


void emission_commande (char commande[])  //ajout tp2 de reseau
{
char c;
char reponse[80];
int i=0;
do
{
  emission_octet(commande[i]);
  c=reception_octet();
  cout<<c;
  if (c!=commande[i]) erreur("ERREUR EMISSION CMD");
  i++;
}
while(commande[i]!=0);
emission_octet(CR);   // carriage return
c=reception_octet();
//if (c!=CR) erreur("AUTRE ERREUE");
recevoir_reponse_modem(reponse);
cout<<endl;
}


void init_modem()             //ajout du tp2 de reseau
{
emission_commande("at&f");
//emission_commande("atz");
emission_commande("att");
emission_commande("ats0=3");
emission_commande("atm");
if (minitel==1) emission_commande("atb2");   // minitel
}

em_ch_minitel(char* ch)
{
int i=0;
while(ch[i]!=0)
{
emission_octet(ch[i]);
cout<<ch[i];
i++;
}
}

appel_minitel()
{
char c,d;
char tab[43]={LF,'R','I','N','G',CR,LF,CR,LF,'R','I','N','G',
CR,LF,CR,LF,'R','I','N','G',CR,LF,CR,LF,
'C','O','N','N','E','C','T',' ','1','2','0','0','/','7','5',CR,LF};
for (int i=0;i!=42;i++)
{
c=reception_octet(); //lf
if (c!=tab[i]) {cout<<"erreur";exit(0);}
cout<<c<<flush;
}

em_ch_minitel("36.19 Moi: Connexion etablie  25F/s \x0a \x0d");
em_ch_minitel(
"\x0d
 \x0d            $$$
 \x0d           $&$
 \x0d            $#$
 \x0d             $
 \x0d            $$$
 \x0d           $ $ $
 \x0d          $  $  $  BIENVENUE !!
 \x0d            $$$
 \x0d           $   $
 \x0d          $     $
 \x0d
\x11
 "); //x11=curseur on

cout<<endl;
do
{
c=reception_octet();
if(c!=DC3) {cout<<c<<flush;  emission_octet(c)/*echo*/ ;  }
else
  {
  d=reception_octet();
  switch (d)
  {
  case '\x41': em_ch_minitel("\x0a \x0d");break;    // Envoie
  case '\x42': em_ch_minitel("-> Touche Retour     Pressee.\x0a \x0d");break;
  case '\x43': em_ch_minitel("-> Touche Repetition Pressee.\x0a \x0d");break;
  case '\x44': em_ch_minitel("-> Touche Guide      Pressee.\x0a \x0d");break;
  case '\x45': em_ch_minitel("\x0d\x18");break; // annulation
  case '\x46': em_ch_minitel("-> Touche Sommaire   Pressee.\x0a \x0d");break;
  case '\x47': em_ch_minitel("\x08\x18");break;   // corection
  case '\x48': em_ch_minitel("-> Touche Suite      Pressee.\x0a \x0d");break;
  case '\x49': em_ch_minitel("Connexion Terminee ! \x0a \x0d ");break;
  }
  }

}
while(c!=DC3 || d!='\x49');
cout<<endl;
}

/*----- TRAITER_RECEPTION_CLAVIER ------------------------*/

void traiter_reception_clavier(char c,BOOLEAN b)
{

 if(b) {
   switch(c) {
          case ALT_X: exit(0);
                     break;
          case F1:
                     util_emet();
                     break;
          case F2:   util_recept();
                     break;
          case F3:   emmetre_fichier(); //fichier texte
           default   :
		     erreur("Caractere clavier invalide");
		     break;
	  }
   }
 else {
    putch(c);
    emission_octet(c);
    }
}

/*----- TRAITER_RECEPTION_PORT_SERIE ---------------------*/

void traiter_reception_port_serie(char c)
{
  if (minitel==1) if (c==CR) appel_minitel();
  if (c==STX) recevoir_fichier();      // reception fichier texte
  if (c==DC1) serveur_recepteur();
  if (c==DC2) serveur_emmeteur();
  else putch(c);
}

/*----- MAIN ---------------------------------------------*/

void main(int argc,char* argv[])
{
 if (argc<2) {cout<<"arguments: 'transfert' ou 'minitel' necessaire";exit(0);}

 if (!strcmp(argv[1],"minitel")) minitel=1;

 char    car_clavier,car_recu;
 BOOLEAN b_special;

 printf("%s\n",BANDEAU);
 if(minitel==1)
 init_controleur(COM3,1200,7,1,PAIRE,60); //minitel
 else
 init_controleur(COM3,14400,8,1,SANS,2);           //xmodem
 setjmp(point_de_retour);
 binit_modem=true;
 init_modem();
 binit_modem=false;
 car_clavier=' ';
 b_special=FALSE;
 do {
    if(lire_clavier(&car_clavier,&b_special))
       traiter_reception_clavier(car_clavier,b_special);
    if(recevoir_octet(&car_recu))
       traiter_reception_port_serie(car_recu);
    } while(car_clavier!=ALT_X || !b_special);
 restaure_controleur();
 emission_commande("ATH");
 exit(1);                           /* a cause du setjmp */
}
